﻿#targetengine "hasira12"

//ドキュメント確認
app.activate();
if(app.documents.length==0){
alert("InDesignドキュメントを開いてから実行してください。");
exit() ;
}else if(app.documents.length>1){
	alert("複数のInDesignドキュメントを開いている場合、最前面ドキュメントのみが処理対象となります。");
	}
if(app.documents[0].saved==false){
		alert("処理対象のInDesignドキュメントを保存してから実行してください。");
		exit() ;
}
var doc = app.documents[0] ;

///一覧を生成
var myList=new String;
myList=("");

//検索オプションGrep
app.changeGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences = NothingEnum.nothing;
app.findChangeGrepOptions.includeHiddenLayers = true;//非表示レイヤーを含めるかどうか
app.findChangeGrepOptions.includeMasterPages = true;//マスターページを含めるかどうか
app.findChangeGrepOptions.includeFootnotes = true;//脚注を含めるかどうか
app.findGrepPreferences.findWhat= "\[\\\S\\\s\~F\]\+" ;//脚注マーカがあっても検索できるように

//スタイル読み込み（フォルダは1階層であれば可）
var slist ;
var slistOld=slist+"";//いったん退避
//alert(slistOld)
slist = "";
for (i = 0; i < app.activeDocument.paragraphStyles.length; i++) {
	slist = slist + app.activeDocument.paragraphStyles[i].name + ",";
	}
for (i = 0; i < app.activeDocument.paragraphStyleGroups.length; i++) {
	var tmpStr = app.activeDocument.paragraphStyleGroups[i].name
	for (j = 0; j < app.activeDocument.paragraphStyleGroups[i].paragraphStyles.length; j++) {
		slist = slist + tmpStr + " __ " + app.activeDocument.paragraphStyleGroups[i].paragraphStyles[j].name + ",";
		}
	}
slist = slist.replace ("[段落スタイルなし]", "（未選択）");
slist = slist.substring (0, slist.length-1);
slist = slist.split (",");
var slistNew=slist+"";//いったん退避

var myPStyle1SelectedIndex;
if (myPStyle1SelectedIndex==null){
myPStyle1SelectedIndex=0};
var myPStyle2SelectedIndex;
if (myPStyle2SelectedIndex==null){
myPStyle2SelectedIndex=0};
var myPStyle3SelectedIndex;
if (myPStyle3SelectedIndex==null){
myPStyle3SelectedIndex=0};
var myPStyle4SelectedIndex;
if (myPStyle4SelectedIndex==null){
myPStyle4SelectedIndex=0};
//var myPStyle11SelectedIndex;
//if (myPStyle11SelectedIndex==null){
//myPStyle11SelectedIndex=0};
var myPStyle21SelectedIndex;
if (myPStyle21SelectedIndex==null){
myPStyle21SelectedIndex=0};
var myPStyle22SelectedIndex;
if (myPStyle22SelectedIndex==null){
myPStyle22SelectedIndex=0};
if(slistOld!=slist){    //段落スタイルのリストに変更があった場合は初期値に
    myPStyle1SelectedIndex=0;
    myPStyle2SelectedIndex=0;
    myPStyle3SelectedIndex=0;
    myPStyle4SelectedIndex=0;
    myPStyle11SelectedIndex=0;
    myPStyle21SelectedIndex=0;
    myPStyle22SelectedIndex=0;
}

//var autoNumStyleSelectedIndex;
//if (autoNumStyleSelectedIndex==null){
//autoNumStyleSelectedIndex=0};
//var prefixContents;
//if (prefixContents==null){
//        prefixContents="";
//        }
//var suffixContents;
//if (suffixContents==null){
//        suffixContents="";
//        }
//var mySeparatorSelectedIndex;
//if (mySeparatorSelectedIndex==null){
//mySeparatorSelectedIndex=1};
var myXCoordinateValue;
if (myXCoordinateValue==null){
        myXCoordinateValue=10;
        }
var myYCoordinateValue;
if (myYCoordinateValue==null){
        myYCoordinateValue=10;
        }
var myWidthValue;
if (myWidthValue==null){
        myWidthValue=50;
        }
var myHeightValue;
if (myHeightValue==null){
        myHeightValue=10;
        }

//ダイアログ表示
var dlg = app.dialogs.add( {name:"柱の作成に関する設定"} );
	with(dlg){
		with(dialogColumns.add() ){
			var bp1 = borderPanels.add();
			with(bp1) {
				with(dialogColumns.add() ){
					with(dialogRows.add()){
						staticTexts.add({staticLabel:"見出しの段落スタイル（4つまで）", minWidth:40 });
					}
					with(dialogRows.add()){
						var myPStyle1 = dropdowns.add({stringList: slist, selectedIndex:myPStyle1SelectedIndex, minWidth:120});
					}
					with(dialogRows.add()){
						var myPStyle2 = dropdowns.add({stringList: slist, selectedIndex:myPStyle2SelectedIndex, minWidth:120});
					}
                	 with(dialogRows.add()){
						var myPStyle3 = dropdowns.add({stringList: slist, selectedIndex:myPStyle3SelectedIndex, minWidth:120});
					}
                	 with(dialogRows.add()){
						var myPStyle4 = dropdowns.add({stringList: slist, selectedIndex:myPStyle4SelectedIndex, minWidth:120});
					}
				}
			}
//        var bp2 = borderPanels.add();
//			with(bp2) {
//				with(dialogColumns.add() ){
//					with(dialogRows.add()){
//						staticTexts.add({staticLabel:"自動番号の形式", minWidth:40 });
//					}
//					with(dialogRows.add()){
//						var autoNumStyle = dropdowns.add({stringList:["1, 2, 3, 4...", "01, 02, 03...", "I, II, III, IV", "i, ii, iii, iv...", "A, B, C, D...", "a, b, c, d...", "001, 002, 003...", "0001, 0002, 0003...", "一、二、三、四...", "（カタカナ）ア, イ, ウ, エ, オ...", "（カタカナ）イ, ロ, ハ, ニ...", "丸数字"], selectedIndex:autoNumStyleSelectedIndex});
//					}
//				}
//			}
//        var bp3 = borderPanels.add();
//			with(bp3) {
//				with(dialogColumns.add() ){
//					with(dialogRows.add()){
//						staticTexts.add({staticLabel:"プレフィックス", minWidth:40 });
//                         var prefix=textEditboxes.add({editContents:prefixContents,minWidth:60});
//						staticTexts.add({staticLabel:"サフィックス", minWidth:40 });
//                         var suffix=textEditboxes.add({editContents:suffixContents,minWidth:60});
//					}
//				}
//			}
//        var bp4 = borderPanels.add();
//			with(bp4) {
//				with(dialogColumns.add() ){
//					with(dialogRows.add()){
//						staticTexts.add({staticLabel:"区切り文字", minWidth:40 });
//                         var mySeparator = dropdowns.add({stringList:["なし", "全角スペース", "タブ"], selectedIndex:mySeparatorSelectedIndex});//最後に検索置換で処理しようと思う
//					}
//				}
//			}
         var bp5 = borderPanels.add();
			with(bp5) {
				with(dialogColumns.add() ){
					with(dialogRows.add()){
						staticTexts.add({staticLabel:"柱のテキストフレーム", minWidth:40 });
					}
					with(dialogRows.add()){
						staticTexts.add({staticLabel:"X", minWidth:20 });
						var myXCoordinate=realEditboxes.add({editValue:myXCoordinateValue,minWidth:40});
						staticTexts.add({staticLabel:"Y", minWidth:20 });
						var myYCoordinate=realEditboxes.add({editValue:myYCoordinateValue,minWidth:40});
						staticTexts.add({staticLabel:"W", minWidth:20 });
						var myWidth=realEditboxes.add({editValue:myWidthValue,minWidth:40});
						staticTexts.add({staticLabel:"H", minWidth:20 });
						var myHeight=realEditboxes.add({editValue:myHeightValue,minWidth:40});					}
				}
			}
			var bp6 = borderPanels.add();
			with(bp6) {
				with(dialogColumns.add() ){
					with(dialogRows.add()){
						staticTexts.add({staticLabel:"柱の段落スタイル", minWidth:40 });
					}
                	 with(dialogRows.add()){
						var myPStyle11 = dropdowns.add({stringList: slist, selectedIndex:myPStyle11SelectedIndex, minWidth:120});
					}
				}
			}
			var bp7 = borderPanels.add();
			with(bp7) {
				with(dialogColumns.add() ){
					with(dialogRows.add()){
						staticTexts.add({staticLabel:"扉判定用の段落スタイル", minWidth:40 });
					}
                	 with(dialogRows.add()){
						var myPStyle21 = dropdowns.add({stringList: slist, selectedIndex:myPStyle21SelectedIndex, minWidth:120});
					}
                	 with(dialogRows.add()){
						var myPStyle22 = dropdowns.add({stringList: slist, selectedIndex:myPStyle22SelectedIndex, minWidth:120});
					}
				}
			}        
		}			
	}
flag =dlg.show();
if(flag){

// 定規の単位-開始位置を保存
var myRulerOrigin = doc.viewPreferences.rulerOrigin;
// 定規の単位-開始位置を「ページ」にする
doc.viewPreferences.rulerOrigin = RulerOrigin.pageOrigin;

//デフォルトの文字スタイルを「なし」にする
doc.textDefaults.appliedCharacterStyle = doc.characterStyles[0];

//オブジェクトスタイルを追加
if(doc.objectStyles.itemByName("柱os")==null){
doc.objectStyles.add({name:"柱os",strokeColor:doc.swatches.item(0) });
}

//既存の柱を削除
for ( i = doc.pageItems.length - 1 ; i >= 0 ; i-- ){
    if(doc.pageItems[ i ].name== "柱" ){
        doc.pageItems[ i ].remove ( ) ;
        }
    }

myPStyle1SelectedIndex=myPStyle1.selectedIndex;
myPStyle2SelectedIndex=myPStyle2.selectedIndex;
myPStyle3SelectedIndex=myPStyle3.selectedIndex;
myPStyle4SelectedIndex=myPStyle4.selectedIndex;
//autoNumStyleSelectedIndex=autoNumStyle.selectedIndex;
//prefixContents=prefix.editContents;
//suffixContents=suffix.editContents;
//mySeparatorSelectedIndex=mySeparator.selectedIndex;
myXCoordinateValue=myXCoordinate.editValue;
myYCoordinateValue=myYCoordinate.editValue;
myWidthValue=myWidth.editValue;
myHeightValue=myHeight.editValue;
myPStyle11SelectedIndex=myPStyle11.selectedIndex;
myPStyle21SelectedIndex=myPStyle21.selectedIndex;
myPStyle22SelectedIndex=myPStyle22.selectedIndex;
//var mySeparator="";
//if(mySeparatorSelectedIndex==1){
//    mySeparator="〓"}
//else if(mySeparatorSelectedIndex==2){
//        mySeparator="〓〓"}

makeList(myPStyle1);
makeList(myPStyle2);
makeList(myPStyle3);
makeList(myPStyle4);

if(myPStyle11.selectedIndex==0){myPStyle11.selectedIndex=1};//（未選択）なら［基本段落］にする
var tmpPStyle2 = myPStyle11.stringList[myPStyle11.selectedIndex];
if(myPStyle11.selectedIndex!=0){
if (flag == true){
//スタイル取り出し
if (tmpPStyle2.match (" __ ")) {
	var PStyle2 = tmpPStyle2.split(" __ ");
hPStyle = doc.paragraphStyleGroups.itemByName(PStyle2[0]).paragraphStyles.itemByName(PStyle2[1]);
	} else {
hPStyle = doc.paragraphStyles.itemByName(tmpPStyle2);
		}
    }
}

function makeList(pSt){
var tmpPStyle = pSt.stringList[pSt.selectedIndex];
if(pSt.selectedIndex!=0){
if (flag == true){
//スタイル取り出し
if (tmpPStyle.match (" __ ")) {
	var PStyle = tmpPStyle.split(" __ ");
app.findGrepPreferences.appliedParagraphStyle = doc.paragraphStyleGroups.itemByName(PStyle[0]).paragraphStyles.itemByName(PStyle[1]);
	} else {
app.findGrepPreferences.appliedParagraphStyle = doc.paragraphStyles.itemByName(tmpPStyle);
		}
    }
var gr=doc.findGrep(); // 検索だけ
var grl=gr.length; 
var newWord;
for (i=0; i<grl; i++) { 
try{
var newWord=gr[i].contents; 
var newIndex = gr[i].index ;
var newPageName = gr[i].parentTextFrames[0].parentPage.name;
//var newNum=gr[i].numberingResultNumber;
var newBltAndNum = gr[i].bulletsAndNumberingResultText ;
var newHashiraContents = newBltAndNum + newWord ;
newHashiraContents = newHashiraContents.replace(/\t/g,"〓〓");    //区切り文字のタブは〓〓に（後で全角スペース）
//alert(newHashiraContents) ; //これで十分！

//alert(gr[i].bulletsAndNumberingListType)
//alert(gr[i].bulletsAndNumberingResultText)  //「自動番号」欄の内容：「記号」の場合は区切り文字含む

//alert(gr[i].numberingExpression)
//alert(gr[i].numberingFormat)


if(newPageName % 2 == 0){
    newPageName=newPageName*1+1;
    }
myList=(myList+"\r"+newIndex+"\t"+newPageName+"\t"+newHashiraContents);
}catch(e){}
}
}
}
myList=myList.replace(/[\u0007\u0003\u200C\n\u0004\uFFFC]/g,"");	//「ここまでインデント」文字、先頭文字スタイルの終了文字、結合なし、強制改行、脚注番号マーカ、アンカーマーカを削除
myList=myList.replace(/\r+/g,"\r"); 
myList=myList.replace(/^\r/g,""); 

//alert(myList);  //ここまではOK?



//外部テキストファイルを用意
saveFolderPath = app.documents[0].filePath; // ドキュメントの保存フォルダ
fileObj = new File(saveFolderPath +"/●●●.txt");
fileObj.encoding="UTF8";

flag = fileObj.open("w");
if (flag){
fileObj.writeln(myList);
fileObj.close();

//文字列を生成
var myList2=new String;
myList2=("");
//配列を作成
var ary = [];

////ソート/////

flagA = fileObj.open("r");
if (flagA)
{
countA = 0;
TAB = String.fromCharCode(9);	// タブコード

while(!fileObj.eof)
{
textA = fileObj.readln();	//　１行読み込む
txtItemA = textA.split(TAB);	//　タブコードで分割
ary.push(txtItemA);//配列の最後に行を追加
countA++;
}
var  lineNum = countA ;	//行数
var rowNum = txtItemA.length;	//列数
}

function funcCompare(a, b) {
    a[0]=a[0]*1;
    b[0]=b[0]*1;
	if (a[1] < b[1]) return -1;
	if (a[1] > b[1]) return 1;
	if (a[0] < b[0]) return -1;
	if (a[0] > b[0]) return 1;
	if (a[rowNum-1]*1 < b[rowNum-1]*1) return -1;
	if (a[rowNum-1]*1 > b[rowNum-1]*1) return 1;
	return 0;
}

var newAry=ary.sort(funcCompare);
var aLength = newAry.length;

for( i=0 ; i<aLength ; i++ ){
var newTxt = newAry[i].join( "\t" );
myList2 = myList2 + newTxt + "\r" ;
}

//myList2=myList2.replace(/\t-1\t/g,"\t\t");  //数字なしの場合の「-1」を削除
//alert(myList2);

flag = fileObj.open("w");
if (flag){
fileObj.writeln(myList2);
fileObj.close();
}

/////重複削除/////

var myList3=new String;
myList3=("");

//配列を作成
var ary = [];
flagA = fileObj.open("r");
if (flagA)
{
countA = 0;
while(!fileObj.eof)
{
textA = fileObj.readln();	//　１行読み込む
txtItemA = textA.split(TAB);	//　タブコードで分割

ary.push(txtItemA);//配列の最後に行を追加
countA++;
}
var rowNum = txtItemA.length;	//列数
}

for( i=ary.length-1 ; i>0 ; i-- ){
if( ary[i][1]==ary[i-1][1] ){   //2項目め（ノンブル）が同じなら前行を削除
//alert(ary[i][0]);
ary.splice(i-1, 1);
}
}

var myPageName = doc.pages[0].name*1 + doc.pages.length-1;
if( ( myPageName % 2 ) == 0 ) {
    myPageName=myPageName-1;  //最終が偶数ページだったら1を引く
    }

//ファイルに書き込み保存
for( k=ary.length-1 ; k>=0 ; k-- ){

//alert(ary[k]);
var pageNum1 = ary[k][1];
var shouNum1 = ary[k][2];
var midashiContents1 = ary[k][3];

//alert(shouNum1)
//if(shouNum1 != ""){
//var hashiraA = shouNum1 + midashiContents1;
//}else{
//    var hashiraA = midashiContents1;
//    }
hashiraA = shouNum1 ;
//alert(hashiraA);
//alert(pageNum1);

while(myPageName >= pageNum1){
//alert(myPageName+"ページ");
//alert(pageNum1);

hashiraTxt = doc.pages[myPageName-doc.pages[0].name*1].textFrames.add();
hashiraTxt.name = "柱";
hashiraTxt.visibleBounds = [ myYCoordinateValue , myXCoordinateValue , myYCoordinateValue+myHeightValue , myXCoordinateValue+myWidthValue ];//上辺, 左辺, 下辺, 右辺
hashiraTxt.contentType = ContentType.textType;
hashiraTxt.parentStory.storyPreferences.storyOrientation = HorizontalOrVertical.horizontal;//横組み
hashiraTxt.contents = hashiraA ;
hashiraTxt.appliedObjectStyle=doc.objectStyles.itemByName( "柱os" );
hashiraTxt.paragraphs[0].appliedParagraphStyle=hPStyle;
hashiraTxt.move(doc.layers[0]); //最前面レイヤーへ
myPageName=myPageName-2;
}

myList3 = myList3 + hashiraA + "\r" ;
}

//alert(myList3);
flag = fileObj.open("w");
if (flag){
fileObj.writeln(myList3);
fileObj.close();
}
}

//〓を置換
app.findGrepPreferences.appliedParagraphStyle = hPStyle ;
app.findGrepPreferences.findWhat = "〓〓";
app.changeGrepPreferences.changeTo = "~(";
app.changeGrep();

//後片付け
app.findGrepPreferences = NothingEnum.nothing;
app.changeGrepPreferences = NothingEnum.nothing;
//開始位置を元に戻す
doc.viewPreferences.rulerOrigin = myRulerOrigin;
fileObj.remove();

removeHashira(myPStyle21);
removeHashira(myPStyle22);

function removeHashira(pSt3){
var tmpPStyle3 = pSt3.stringList[pSt3.selectedIndex];
if(pSt3.selectedIndex!=0){
if (flag == true){
//スタイル取り出し
if (tmpPStyle3.match (" __ ")) {
	var PStyle3 = tmpPStyle3.split(" __ ");
app.findGrepPreferences.appliedParagraphStyle = doc.paragraphStyleGroups.itemByName(PStyle3[0]).paragraphStyles.itemByName(PStyle3[1]);
	} else {
app.findGrepPreferences.appliedParagraphStyle = doc.paragraphStyles.itemByName(tmpPStyle3);
		}
    }
var gr=doc.findGrep(); // 検索だけ
var grl=gr.length; 
var newWord;
for (i=0; i<grl; i++) { 
try{
var newPageName = gr[i].parentTextFrames[0].parentPage.name;
var newPageIndex = newPageName-doc.pages[0].name*1 ;
//alert(newPageName);
//alert(doc.pages[newPageIndex].pageItems.length)
for ( j = doc.pages[newPageIndex].pageItems.length - 1 ; j >= 0 ; j-- ){
if(doc.pages[newPageIndex].pageItems[ j ].name== "柱" ){
    doc.pages[newPageIndex].pageItems[ j ].remove ( ) ;
    }
}
}catch(e){}
}
}
}
}